#include<stdio.h>
#include<string.h>
#include<stdlib.h>
//#include"commanod_LCDClib.h"
#include"main.h"
//#include"color.h"



//command_LCDClibの宣言
unsigned short LCDCusX,LCDCusY;
char LCDC_Command[100];
char serialDataBuff[500];

int serialBuffCount;
char *string1;
char string2[45];
unsigned short LCDCFontX,LCDCFontY;
unsigned char LCDCFontcl1,LCDCFontcl2;
char hexbuf[8];
int command_returncheck_flag;
int checksum_command_flag;
int return_command_flag;
int RTS_flag;
unsigned int uiX1,uix2,uiY1,uiY2,LCDCADuiX,LCDCADuiY;
unsigned int uiMin_AD_x,uiMax_AD_x,uiMin_AD_y,uiMax_AD_y;
//--------------------


void fnSerial_Decision(void);

short htoi(char *ptr3){
        unsigned short v;

        for(v = 0;(*ptr3 >= '0' && *ptr3 <= '9') || (*(ptr3) >= 'A' && *(ptr3) <= 'F') || (*(ptr3) >= 'a' && *(ptr3) <= 'f');ptr3++){
                if(*(ptr3) >= '0' && *(ptr3) <= '9') v = v*0x10 +(*ptr3 - 0x30);
                else if(*(ptr3) >= 'A' && *(ptr3) <= 'F') v = v*0x10+(*ptr3-0x37);
                else if(*(ptr3) >= 'a' && *(ptr3) <= 'f') v = v*0x10+(*ptr3-0x57);
        }
        return v;
}
/*--------------------------------------------------
関数名　fnLCDCInit
	commandLCDClibに使用する変数の初期化
--------------------------------------------------*/
void fnLCDCInit(void){
        //command_LCDClibの初期化
        command_returncheck_flag = 0;
        checksum_command_flag = 0;
        return_command_flag = 0;
        RTS_flag = 0;
	serialBuffCount = 0;

        uiMin_AD_x = 40;                //X軸A/D変換値 MIN
        uiMin_AD_y = 130;               //Y軸A/D変換値 MIN
        uiMax_AD_x = 855;               //X軸A/D変換値 MAX
        uiMax_AD_y = 935;               //Y軸A/D変換値 MAX
/*      下800用設定
        uiMin_AD_x = 63;                //X軸A/D変換値 MIN
        uiMin_AD_y = 143;               //Y軸A/D変換値 MIN
        uiMax_AD_x = 947;               //X軸A/D変換値 MAX
        uiMax_AD_y = 944;               //Y軸A/D変換値 MAX
*/
}
/*-------------------------------------------------
関数名　tohex
	SmartLCDCへ送信するために数字部分をhexへ変換する関数
	変換後hexbufへ代入される。

-------------------------------------------------*/
void tohex1(unsigned int ptr){
        if(10 > ptr % 16){
                hexbuf[0] = ptr%16 + 0x30;
        }else{
                hexbuf[0] = (ptr%16) + 0x37;
        }
        hexbuf[1] = '\0';
}
void tohex2(unsigned int ptr){
        if(10 > ptr % 16){
                hexbuf[1] = ptr%16 + 0x30;
        }else{
                hexbuf[1] = (ptr%16) + 0x37;
        }

        ptr = ptr/16;

        if(10 > ptr % 16){
                hexbuf[0] = ptr%16 + 0x30;
        }else{
                hexbuf[0] = (ptr%16) + 0x37;
        }

        hexbuf[2] = '\0';
}
void tohex3(unsigned int ptr){
        if(10 > ptr % 16){
                hexbuf[2] = ptr%16 + 0x30;
        }else{
                hexbuf[2] = (ptr%16) + 0x37;
        }

        ptr = ptr/16;

        if(10 > ptr % 16){
                hexbuf[1] = ptr%16 + 0x30;
        }else{
                hexbuf[1] = (ptr%16) + 0x37;
        }

        ptr = ptr/16;

        if(10 > ptr % 16){
                hexbuf[0] = ptr%16 + 0x30;
        }else{
                hexbuf[0] = (ptr%16) + 0x37;
        }

        hexbuf[3] = '\0';
}

void tohex4(unsigned int ptr){
        if(10 > ptr % 16){
                hexbuf[3] = ptr%16 + 0x30;
        }else{
                hexbuf[3] = (ptr%16) + 0x37;
        }

        ptr = ptr/16;
        if(10 > ptr % 16){
                hexbuf[2] = ptr%16 + 0x30;
        }else{
                hexbuf[2] = (ptr%16) + 0x37;
        }

        ptr = ptr/16;

        if(10 > ptr % 16){
                hexbuf[1] = ptr%16 + 0x30;
        }else{
                hexbuf[1] = (ptr%16) + 0x37;
        }

        ptr = ptr/16;

        if(10 > ptr % 16){
                hexbuf[0] = ptr%16 + 0x30;
        }else{
                hexbuf[0] = (ptr%16) + 0x37;
        }

        hexbuf[4] = '\0';
}
/*----------------------------------------------
関数名 tochecksum
	チェックサムが有効な場合、送信するときにチェックサムを作る関数。
----------------------------------------------*/
void tochecksum(unsigned int ptr){
        hexbuf[1] = ptr%16 + 0x30;
        ptr = ptr/16;
        hexbuf[0] = ptr%16 + 0x30;
        hexbuf[2] = '\0';
}
/*----------------------------------------------
関数名 returncheck
        リターンコマンドが有効な場合、リターンコマンドを確認する関数。
----------------------------------------------*/
void returncheck(void){
        int maticount1,maticount2;
        command_returncheck_flag = 1;

        for(maticount1 = 0;maticount1<0xffff; maticount1++){
                for(maticount2 = 0;maticount2 < 0xffff;maticount2++){
                        fnSerial_Decision();
                        if(command_returncheck_flag == 0) break;
                }
                if(command_returncheck_flag == 0) break;
        }
//	printf("rturn_check OK\r\n");
}

void fnMake_sum_and_Trans(void){
        int i;
        unsigned char checksum;

        i = 0;
        checksum = '\0';

        if(RTS_flag == 1){
//              while(RTS_PIN == 1){            //#defineでRTS_PINの設定を行ってください。
//                      //RTS_PINがHighの時は待つ。
//              }
        }

        //チェックサムの設定が有効の場合、コマンドからチェックサムを作る。
        if(checksum_command_flag == 1){
                while(string1[i] != '\0'){
                        checksum += string1[i];
                        i++;
                }
                i = 0;
                while(string2[i] != '\0'){
                        checksum += string2[i];
                        i++;
                }
                tochecksum(checksum);
                strcat(string2,hexbuf);
        }
        strcpy(LCDC_Command,string1);
        strcat(LCDC_Command,string2);
        fnputus(LCDC_Command);
//	printf(LCDC_Command);	//コンソールに出力
//	printf("\r\n");		//コンソールに出力
	if(return_command_flag == 1){
		fnLCDCR(1);
                returncheck();
        }
}

/*----------------------------------------------
関数名 fnt　関連
        SmartLCDCからtコマンドが来た時に処理する関数。
	主にタッチパネルからの座標を処理して、数値に変換し変数へ代入する。
----------------------------------------------*/

void fntget(char *ptr){
        char LCDCdataX[4],LCDCdataY[4];
        unsigned short ulPitch1000;

        ptr++;
        LCDCdataX[0] = *ptr;
        ptr++;
        LCDCdataX[1] = *ptr;
        ptr++;
        LCDCdataX[2] = *ptr;
        LCDCdataX[3] = '\0';

        ptr++;
        LCDCdataY[0] = *ptr;
        ptr++;
        LCDCdataY[1] = *ptr;
        ptr++;
        LCDCdataY[2] = *ptr;
        LCDCdataY[3] = '\0';

        LCDCADuiX = htoi(LCDCdataX);
        LCDCADuiY = htoi(LCDCdataY);

//	LCDCusX = (LCDCADuiX / 2) -10;
//	LCDCusY = LCDCADuiY / 3.7;

        ulPitch1000 = (unsigned int)(uiMax_AD_x - uiMin_AD_x)*1000 /(LCDC_XSCL - 1);
        LCDCusX = (unsigned short)((unsigned int)(LCDCADuiX - uiMin_AD_x) * 1000/ ulPitch1000);
        ulPitch1000 = (unsigned int)(uiMax_AD_y - uiMin_AD_y)*1000 /(LCDC_YSCL - 1);
        LCDCusY = (unsigned short)((unsigned int)(LCDCADuiY - uiMin_AD_y) * 1000/ ulPitch1000);

}

void fnt(char *ptr){
        ptr++;
        if(*ptr == '1'){
                //タッチパネルが押されている時
                fntget(ptr);
        }else if(*ptr == '0'){
                //タッチパネルが離されているとき
                LCDCusX = 0;
                LCDCusY = 0;
        }else{
        }
}

void fnLCDC_RTSset(int type){
        if(type == 1){
                RTS_flag = 1;
        }else{
                RTS_flag = 0;
        }
}
/*
void fnSerialRead(void){
        while(serialDataAvail(fd)){
                rBuffer[serialBuffCount] = serialGetchar(fd);
                fflush(stdout);

              putchar(rBuffer[serialBuffCount]);
//		printf("\r\n");
                serialBuffCount++;
                if(serialBuffCount >= 500){
                        serialBuffCount = 0;
                }
        }
}
*/

/*-----------------------------------
関数名 fnSerial_Decision
	受信したSmartLCDCからのコマンドを解析するリングバッファ処理。

-----------------------------------*/
void fnSerial_Decision(void){
        char *ptr;

        fnSerialRead();
        //コマンドの文字読み取りリングバッファ部
        for(;;){
                if(inCount == outCount) break;
                if(inCount != outCount){
                        cBuffer[usBufCount] = rBuffer[outCount];
                        usBufCount++;
                        if(usBufCount >= 499) cBuffer[0] = 0x0d;
                        if(++outCount > 499) outCount = 0;
                }
                if((usBufCount >= 1) && (cBuffer[usBufCount-1] == CR)) break;
        }
        //コマンド解析部

        if((usBufCount >= 1) && (cBuffer[usBufCount-1] == CR)){
		usBufCount = 0;

                ptr = cBuffer;
                switch(*ptr){
                        case 't':
                                fnt(ptr);
                                break;
                        default:
                                break;
                }
                ptr++;
                switch(*ptr){
                        case 'k':
                                command_returncheck_flag = 0;
                                break;
                        case 'E':
        //                      command_returncheck_flag = 0;
                                break;
                        default:
                                break;
                }
        }
}

/*---------------------------------
以下、各SmartLCDCようの操作コマンド
---------------------------------*/
void fnLCDCt(unsigned int type){
	string1 = "t";
	tohex1(type);
	strcpy(string2,hexbuf);
	fnMake_sum_and_Trans();
}

void fnLCDCH(unsigned int type){
	string1 = "H";
	tohex1(type);
	strcpy(string2,hexbuf);
	fnMake_sum_and_Trans();
}

void fnLCDCI(unsigned int type){
        string1 = "I";
        tohex1(type);
        strcpy(string2,hexbuf);
        fnMake_sum_and_Trans();
}

void fnLCDCR(unsigned int type){
	string1 = "R";
	tohex1(type);
	strcpy(string2,hexbuf);
	if(type == 1){
		return_command_flag = 1;
	}else{
		return_command_flag = 0;
	}
	fnMake_sum_and_Trans();
}

void fnLCDCDot(unsigned int uiX,unsigned int uiY,unsigned int uiC){
	string1 = "D";

	tohex3(uiX);
	strcpy(string2,hexbuf);

        tohex3(uiY);
        strcat(string2,hexbuf);

        tohex4(uiC);
        strcat(string2,hexbuf);

	fnMake_sum_and_Trans();
}

void fnLCDCLine(unsigned int uiX1,unsigned int uiY1,unsigned int uiX2,unsigned int uiY2,unsigned int uiC){
        string1 = "L0";

        tohex3(uiX1);
        strcpy(string2,hexbuf);

        tohex3(uiY1);
        strcat(string2,hexbuf);

        tohex3(uiX2);
        strcat(string2,hexbuf);

        tohex3(uiY2);
        strcat(string2,hexbuf);

        tohex4(uiC);
        strcat(string2,hexbuf);

        fnMake_sum_and_Trans();
}

void fnLCDCPaintBox(unsigned int uiX1,unsigned int uiY1,unsigned int uiX2,unsigned int uiY2,unsigned int uiC){
        string1 = "B0";

        tohex3(uiX1);
        strcpy(string2,hexbuf);

        tohex3(uiY1);
        strcat(string2,hexbuf);

        tohex3(uiX2);
        strcat(string2,hexbuf);

        tohex3(uiY2);
        strcat(string2,hexbuf);

        tohex4(uiC);
        strcat(string2,hexbuf);

        fnMake_sum_and_Trans();
}

void fnLCDCPaintBoxC(unsigned int uiX1,unsigned int uiY1,unsigned int uiX2,unsigned int uiY2,unsigned int uiC){
        string1 = "B1";

        tohex3(uiX1);
        strcpy(string2,hexbuf);

        tohex3(uiY1);
        strcat(string2,hexbuf);

        tohex3(uiX2);
        strcat(string2,hexbuf);

        tohex3(uiY2);
        strcat(string2,hexbuf);

        tohex4(uiC);
        strcat(string2,hexbuf);

        fnMake_sum_and_Trans();

}

void fnLCDCcls(unsigned int uiC){
	fnLCDCPaintBox(0,0,LCDC_XSCL-1,LCDC_YSCL-1,uiC);
}
void fnLCDCcls2(unsigned int uiC){
	unsigned int uiL,uiN;
	for(uiN = 0; uiN < 20;uiN++){
		for(uiL = 0; uiL < LCDC_YSCL; uiL+= 20){
		fnLCDCLine(0,uiL+uiN,0,uiL+uiN,uiC);
		}
	}
}

void fnLCDCFont(unsigned int type,unsigned int size,unsigned int uiX,unsigned int uiY,unsigned int col,unsigned int offcol,char *cp){
        string1 = "F";

        tohex1(type);
        strcpy(string2,hexbuf);

        tohex1(size);
        strcat(string2,hexbuf);

        tohex3(uiX);
        strcat(string2,hexbuf);

        tohex3(uiY);
        strcat(string2,hexbuf);

        tohex4(col);
        strcat(string2,hexbuf);

        tohex4(offcol);
        strcat(string2,hexbuf);

	strcat(string2,cp);

	fnMake_sum_and_Trans();
}
void fnLCDCP(unsigned int type,unsigned int uiX,unsigned int uiY,unsigned int addrees){
	string1 = "P";

        tohex1(type);
        strcpy(string2,hexbuf);

        tohex3(uiX);
        strcat(string2,hexbuf);

        tohex3(uiY);
        strcat(string2,hexbuf);

	tohex4(addrees);
	strcat(string2,hexbuf);

	fnMake_sum_and_Trans();
}
void fnLCDC7seg(unsigned int size,unsigned int uiColum,unsigned int uiX,unsigned int uiY,unsigned int col,unsigned int offcol,int iValue){
	char string3[6];

	string1 = "S";

	tohex1(size);
        strcpy(string2,hexbuf);

        tohex1(uiColum);
        strcat(string2,hexbuf);

        tohex3(uiX);
        strcat(string2,hexbuf);

        tohex3(uiY);
        strcat(string2,hexbuf);

        tohex4(col);
        strcat(string2,hexbuf);

        tohex4(offcol);
        strcat(string2,hexbuf);

	if(uiColum == 1){
		string3[0] = (iValue%10) + 0x30;
		string3[1] = '\0';
	}
        if(uiColum == 2){
		string3[0] = ((iValue/10)%10) + 0x30;
                string3[1] = (iValue%10) + 0x30;
                string3[2] = '\0';
        }
        if(uiColum == 3){
	        string3[0] = ((iValue/100)%10) + 0x30;
	        string3[1] = ((iValue/10)%10) + 0x30;
                string3[2] = (iValue%10) + 0x30;
                string3[3] = '\0';
        }
        if(uiColum == 4){
                string3[0] = ((iValue/1000)%10) + 0x30;
                string3[1] = ((iValue/100)%10) + 0x30;
                string3[2] = ((iValue/10)%10) + 0x30;
                string3[3] = (iValue%10) + 0x30;
                string3[4] = '\0';
        }
        if(uiColum == 5){
                string3[0] = ((iValue/10000)%10) + 0x30;
                string3[1] = ((iValue/1000)%10) + 0x30;
                string3[2] = ((iValue/100)%10) + 0x30;
                string3[3] = ((iValue/10)%10) + 0x30;
                string3[4] = (iValue%10) + 0x30;
                string3[5] = '\0';
        }
	strcat(string2,string3);
	fnMake_sum_and_Trans();

}

void fnLCDCU(unsigned int type){
        string1 = "U";
        tohex1(type);
        strcpy(string2,hexbuf);
	fnMake_sum_and_Trans();

        if(type == 1){
                checksum_command_flag = 1;
        }else{
                checksum_command_flag = 0;
        }
}
